#include <DS3231.h>
#include <Arduino.h>
#include <TM1637Display.h>
//include libraries for rtc, 4-digit display
 
#define CLK 2
#define DIO 3
//define pins 2 and 3 as CLK and DIO for display
 
TM1637Display display(CLK, DIO);
//initializes display
 
DS3231  rtc(SDA, SCL);
 
int count = 0;
int maxCount = 5;
int countDown = 1;
String rtcPrevDate = "1.1.2014";
int state = 0;
int prevButton;
int prevButton2;
int state2 = 0;
int timeThen, timeNow;
 
 
void setup() {
  Serial.begin(9600);
  pinMode(12, OUTPUT);
 
  rtc.begin();
  rtc.setDOW(WEDNESDAY);     // Set Day-of-Week
  rtc.setTime(12, 0, 0);    // Set the time to 12:00:00 (24hr format)
  rtc.setDate(1, 1, 2014);   // Set the date to January 1st, 2014
}
 
 
void loop() {
 
  /*if(digitalRead(11) == 0){
    prevButton2 = digitalRead(11);
  }
 
  if(prevButton2 != digitalRead(11) && digitalRead(11) == 1){
    maxCount = maxCount - countDown;
    count = maxCount;
  }*/
  
  //if date changes then max sigarettes each day goes down by countDown
  if (rtcPrevDate != rtc.getDateStr()) {
    rtcPrevDate = rtc.getDateStr();
    maxCount = maxCount - countDown;
    count = maxCount;
  }
 
  timeNow = rtc.getUnixTime(rtc.getTime());
 
  if (digitalRead(13) == 0 && count > 0) {
    digitalWrite(12, HIGH);
    state = 1;
  } else {
    digitalWrite(12, LOW);
  }
 
  if (prevButton != digitalRead(13) && prevButton != 0 && state2 == 0) {
    state2 = 1;
    timeThen = timeNow;
  }
 
  if (digitalRead(13) == 1 && state == 1 && timeNow - timeThen >= 60) {
    count--;
    state = 0;
    state2 = 0;
    uint8_t blank[] = { 0x00, 0x00, 0x00, 0x00 };
    //initializes variable blank to clear the display
    display.setSegments(blank);
    //clears display
  }
 
  prevButton = digitalRead(13);
 
  display.setBrightness(0x0f);
  //sets brightness of display
  display.showNumberDec(count, false);
  //displays maxCount from left to right without extra 0 digit in front
}
 
/*****************Bluetooth************************/
 
byte count2 = count;
Serial.write(count2);
delay(500);
